/* -------------------------------------------------------------------------- */
/*
	(c) 2005 U.S. Robotics Corporation.
*/
/* -------------------------------------------------------------------------- */


/* --------------------------------------------------------------------------

	Workaround for IE :hover bug.

*/
function initMenu(id)
{
	if (!document.all || !document.getElementById)
		return;

	var navRoot = document.getElementById(id);
	if (navRoot == null)
		return;


	/*
		We only need to do this kludge if it's IE.
		Only do it if there are <select> elements.
	*/
	if (window.navigator.userAgent.indexOf("MSIE") <= 0)
		return;


	var ieLIs = navRoot.getElementsByTagName("LI");
	for (var i = 0; i < ieLIs.length; i++)
	{
		ieLIs[i].onmouseover = function()
										{
											this.className += " fixIE";
										}
		ieLIs[i].onmouseout = function()
										{
											this.className = this.className.replace(" fixIE", "");
										}
	}


	/*
		Fix other IE bug(s).
	*/
	fixIEhover(id);
}

/* --------------------------------------------------------------------------

	BUG: IE always displays SELECT elements on top.
	FIX: Shim an <IFRAME> below the <UL> element.

*/
function fixIEhover(id)
{
	/*
		We only need to do this kludge if it's IE.
	*/
	if (window.navigator.userAgent.indexOf("MSIE") <= 0)
		return;
	/*
		Only do it if there are <select> elements on the page.
	*/
	if (document.getElementsByTagName("SELECT").length == 0)
		return;


	var ieULs = document.getElementById(id).getElementsByTagName("UL");
	/** IE script to cover <SELECT> elements with <IFRAME>s **/
	for (j = 0; j < ieULs.length; j++)
	{
		ieULs[j].innerHTML = '<iframe src="about:blank" scrolling="no" frameborder="0" \
style="position: absolute; left: 0; top: 0; z-index: 0; filter: progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=100);">\
</iframe>' + ieULs[j].innerHTML;

		//also works	var ieMat = ieULs[j].childNodes[0];
		var ieMat = ieULs[j].firstChild;

		ieMat.style.width = "230px";		// same value as for width of "UL#idMenu LI UL LI" style
		// Calculate height of "tallest/longest" menu
		// Test with "opacity=100"
		var iNumItems = ieULs[j].getElementsByTagName("LI").length;
		ieMat.style.height = (iNumItems * ieULs[j].offsetHeight) + "px";

		ieULs[j].style.zIndex = "99";
	}
}



/* --------------------------------------------------------------------------

	Page header and footer functions

*/

/*
	This function returns the filename of the current page.
	It looks for both slash and backward slash.
*/
function getPageFilename()
{
	var strFilename = document.URL;
	var ixSeparator = strFilename.lastIndexOf("/");
	var ixSeparator2 = strFilename.lastIndexOf("\\");
	if (ixSeparator2 > ixSeparator)
		ixSeparator = ixSeparator2;
	if (ixSeparator != -1)
		strFilename = strFilename.substr(ixSeparator + 1);
	return strFilename;
}

/*
	This writes out a page's header, including the optional menu bar.
	The title parameter is optional. If passed, it's written out
	as the header text.

	<ul id="idMenu">
		<li><label>Sunfishes</label>
			<ul>
				<li><a href="">Blackbanded sunfish</a></li>
				<li><a href="">Shadow bass</a></li>
				<li><a href="">Ozark bass</a></li>
				<li><a href="">White crappie</a></li>
			</ul>
		</li>

		<li><label>Grunts</label>
			<ul>
				<li><a href="">Smallmouth grunt</a></li>
				<li><a href="">Burrito</a></li>
				<li><a href="">Pigfish</a></li>
			</ul>
		</li>

		<li><label>Remoras</label>
			<ul>
				<li><a href="">Whalesucker</a></li>
				<li><a href="">Marlinsucker</a></li>
				<li><a href="">Ceylonese remora</a></li>
				<li><a href="">Spearfish remora</a></li>
				<li><a href="">Slender suckerfish</a></li>
			</ul>
		</li>
	</ul>
*/
function writeHeader(strTitle, strUsername, strStd, strProtocol, bIPext, bFirewall, bNAT, strWireless, bQoS)
{
//	var strFilename = getPageFilename();		  // get filename of current page

	document.write("<img id=\"idImgHeader\" src=\"usr_banner.gif\">\n");

	document.write("<div id=\"idHeader\">" + strTitle + "<\/div>\n");

	var menuMain = createMenu(strUsername, strStd, strProtocol, bIPext, bFirewall, bNAT, strWireless, bQoS);

	document.write("<ul id=\"idMenu\">\n");
	for (var i = 0; i < menuMain.length; ++i)
	{
		document.write("<li title=\"" + menuMain[i].strDescription + "\"><label>" + menuMain[i].strTitle + "<\/label>");

		/*
			If the current menu item has a sub-menu, output it too.
		*/
		menuSub = menuMain[i].menuSub;
		if (menuSub != null)
		{
			document.write("<ul>\n");
			for (var j = 0; j < menuSub.length; ++j)
				document.write("<li><a href=\"" + menuSub[j].strFilename + "\" title=\"" + menuSub[j].strDescription + "\">" + menuSub[j].strTitle + "<\/a><\/li>\n");
			document.write("<\/ul>\n");
		}

		document.write("<\/li>\n");
	}
	document.write("<\/ul>\n");

	document.write("<div id=\"idContent\">");
}


/*
	This outputs the header for a Setup page.
	The passed number indicates which step this is and how many steps there are.

	<img id="idImgHeader" src="banner.gif">

	<h2 class="clsSteps">Setup
		<span class="clsStepCurrent">1</span>
		<span class="clsStepNotDone">&hellip; 2 &hellip; 3</span>
	</h2>

	<h2 class="clsSteps">Setup
		<span class="clsStepDone">1 &hellip;</span>
		<span class="clsStepCurrent">2</span>
		<span class="clsStepNotDone">&hellip; 3</span>
	</h2>


	<h2 class="clsSteps">Setup
		<span class="clsStepDone">1 &hellip; 2 &hellip;</span>
		<span class="clsStepCurrent">3</span>
	</h2>
*/
function writeHeaderSetup(iStep, iSteps)
{
	document.write("<img id=\"idImgHeader\" src=\"usr_banner.gif\">");

	document.write("<div id=\"idSteps\">Setup ");

	for (var i = 1; i <= iSteps; ++i)
	{
		if (i == iStep)
			document.write("<span class=\"clsStepCurrent\">" + i + "<\/span> ");
		else
			document.write("<span class=\"clsStepNotDone\">" + i + "<\/span> ");

		if (i < iSteps)
			document.write("<span class=\"clsStepNotDone\">&hellip;<\/span> ");
	}
	document.write("<\/div>");

	document.write("<div id=\"idContent\">");
}


/*
	This writes the header for an "information" page.
*/
function writeHeaderInfo(strName)
{
	document.write("<img id=\"idImgHeader\" src=\"usr_banner.gif\">");
	document.write("<div id=\"idHeader\">" + strName + "<\/div>");
	document.write("<div id=\"idContent\">");
}


function writeFooter()
{
	document.write("<\/div>");	// close "idContent"

	document.write("<p class=\"clsCopyright\">&copy; 2004-2005 <a href=\"http://www.usr.com\">U.S. Robotics Corporation<\/a>.<\/p>");
}



/* --------------------------------------------------------------------------

	General helper functions

*/

/*
	This function tests the passed element's value for being inside
	the passed range--inclusive. If it's not, it displays an error
	and sets focus to the field...and returns false.
*/
function inRange(strName, elt, min, max)
{
	if ((elt.value == "") || (elt.value < min) || (elt.value > max))
	{
		alert("The " + strName + " setting must be between " + min + " and " + max + ", inclusive.");
		elt.focus();
		return false;
	}
	return true;
}

/*
	This function tests the passed element's length for being at least the
	passed number of characters. If it's not, it displays an error and sets
	focus to the field...and returns false.
*/
function minLength(strName, elt, min)
{
	if (elt.value.length < min)
	{
		alert("The " + strName + " field must have at least " + min + " characters.");
		elt.focus();
		return false;
	}

	return true;
}


function toggleVisibility(id)
{
	var elt = document.getElementById(id);
	if ((elt == null) || !elt.style || (elt.style.display == null))
		return;

	if (elt.style.display == "none")
		elt.style.display = "";
	else
		elt.style.display = "none";
}


function setVisibility(id, state)
{
	var elt = document.getElementById(id);
	if ((elt == null) || !elt.style || (elt.style.display == null))
		return;

	if (state)
		elt.style.display = "";
	else
		elt.style.display = "none";
}


function setEnabled(id, state)
{
	var elt = document.getElementById(id);
	if ((elt == null) || !elt.style || (elt.style.display == null))
		return;

	elt.disabled = !state;
}


function validateUsername(elt)
{
	if (elt.value.length == 0)
	{
		alert("Please enter a user name.");
		elt.focus();
		return false;
	}

	return isPrintable("User name", elt);
}

function validatePassword(elt)
{
	if (elt.value.length == 0)
	{
		alert("Please enter a password.");
		elt.focus();
		return false;
	}

	return isPrintable("Password", elt);
}


/*
	This function determines if the passed string contains only printable characters.
	It returns true if the string is okay. It displays an error and returns false
	if the string contains an invalid character.

	95 "printable" characters:
	<space>!"#$%&'()*+,-./:;<=>?@[\]^_`{|}~0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz

	We support ALL "printable" characters in the ASCII and Extended ASCII table.
	These are character codes	32-126, 128-254, inclusive (decimal), or
										0x20-0x7E, 0x80-0xFE, inclusive (hex).
	www.lookuptables.com
*/
function isPrintable(strFieldName, elt)
{
	/*
		Note: We have to escape characters both for Javascript and for RegExp.
				Thus, " must be escaped ONLY for Javascript: \"
						\ and [ and ] must be escaped for RegExp and then the
						escape characters have to be escaped for Javascript:
						\\\\ and \\[ and \\]
	*/
//	var re = new RegExp("[^a-zA-Z0-9 !\"#$%&'()*+,\\-./:;<=>?\\\\@\\[\\]^_`{|}~]", "g");
	var re = new RegExp("[^\\u0020-\\u007E\\u0080-\\u00FE]", "g");

	var arMatch = elt.value.match(re);
	if (arMatch == null)
		return true;

	var strIllegalChars = "";
	for (var i = 0; i < arMatch.length; ++i)
		strIllegalChars += arMatch[i];

	// handle Kevin Willoughby Memorial Bug
//	var strMsg2 = "\n\nPlease use only a-z, A-Z, 0-9, space, or one of these: !\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~";
	var strMsg2 = "\n\nPlease use only a-z, A-Z, 0-9, space, punctuation, or charcters in the extended ASCII set, such as accented characters.";
	if (arMatch.length == 1)
		alert("The " + strFieldName + " entry contains an invalid character: " + strIllegalChars + strMsg2);
	else
		alert("The " + strFieldName + " entry contains invalid characters: " + strIllegalChars + strMsg2);

	elt.focus();
	return false;
}
